#include "pagelockedmem.h"

PageLockedMem::PageLockedMem()
{
	pl_a3dv=NULL;
	pl_a3ds=NULL;
	pl_s3df=NULL;
	pl_s3ds=NULL;
	
	pl_d3dv=NULL;
	pl_d3ds=NULL;
	pl_v3df=NULL;
	pl_v3ds=NULL;
	
	pl_b3dv=NULL;
	pl_b3ds=NULL;
	pl_c3dv=NULL;
	pl_c3ds=NULL;
}

PageLockedMem::~PageLockedMem()
{
	free();
}

void PageLockedMem::free()
{
	cudaFreeHost(pl_a3dv);
	pl_a3dv=NULL;
	
	cudaFreeHost(pl_a3ds);
	pl_a3ds=NULL;
	
	cudaFreeHost(pl_s3df);
	pl_s3df=NULL;
	
	cudaFreeHost(pl_s3ds);
	pl_s3ds=NULL;
	
	cudaFreeHost(pl_d3dv);
	pl_d3dv=NULL;
	
	cudaFreeHost(pl_d3ds);
	pl_d3ds=NULL;
	
	cudaFreeHost(pl_v3df);
	pl_v3df=NULL;
	
	cudaFreeHost(pl_v3ds);
	pl_v3ds=NULL;
	
	cudaFreeHost(pl_b3dv);
	pl_b3dv=NULL;
	
	cudaFreeHost(pl_b3ds);
	pl_b3ds=NULL;
	
	cudaFreeHost(pl_c3dv);
	pl_c3dv=NULL;
	
	cudaFreeHost(pl_c3ds);
	pl_c3ds=NULL;
}
