#include "ainterpo3dbig_gpu.h"
#include "func.h"

CPLX ainterpo3dbig(int nsama, int ipad, CPLX *a3df, CPLX *a3ds, 
                                      float &x, float &y, float &z)
{
	int nsam,jc;
	int l,m,n,ll,mm,nn,is,id,nsamh;
	CPLX samp;
	
	nsam=ipad*nsama;
	samp.x=samp.y=0.0f;
	jc=nsam/2+1;
	nsamh=nsam/2;
	l=(x>=0.0f)?int(ipad*x+0.5f):int(ipad*x-0.5f);
	m=(y>=0.0f)?int(ipad*y+0.5f):int(ipad*y-0.5f);
	n=(z>=0.0f)?int(ipad*z+0.5f):int(ipad*z-0.5f);

	if(l>=0)
	{
		ll=l+1;
		mm=m+1;
		if(mm<1) mm=mm+nsam;
		nn=n+1;
		if(nn<1) nn=nn+nsam;
		if(ll!=jc)
		{
			id=ll+nsamh*((mm-1)+nsam*(nn-1));
			samp=cPc(samp,a3df[id-1]);
		}
		else
		{
			is=mm+nsam*(nn-1);
			samp=cPc(samp,a3ds[is-1]);
		}
	}
	else
	{
		ll=-l+1;
		mm=-m+1;
		if(mm<1) mm=mm+nsam;
		nn=-n+1;
		if(nn<1) nn=nn+nsam;
		if(ll!=jc)
		{
			id=ll+nsamh*((mm-1)+nsam*(nn-1));
			samp=cPc(samp,conjg(a3df[id-1]));
		}
		else
		{
			is=mm+nsam*(nn-1);
			samp=cPc(samp,conjg(a3ds[is-1]));
		}
	}
	return samp;
}    
