#include "boxft_lut_gpu.h"



float boxft_lut(float *arg, float *sinclut)
{
	int i,j;
	float sinc,prod=1.0f;
	
	for(i=0;i<3;i++)
	{
		arg[i]=abs(arg[i]);
		if(arg[i]<0.02f)
		{
			sinc=1.0f;
		}
		else
		{
			j=int(180.0f*arg[i]+0.5f);
			if(j<1 || j>2000) printf("warning: sinclut[%d-1] wrong.\n", j);
			sinc=sinclut[j-1];			
		}
		prod=prod*sinc;
	}
	return prod;

}
